META
{
  Parser = Game;
  Engine = G2, G2A;
};
// global instance of the first and second player
extern INSTANCE hero(C_NPC);
extern INSTANCE hero_2(C_NPC);

//If player 1 or 2 hits an enemy, set the target to the player that hit the enemy (to make the game harder)


//CHOOSE BETWEEN "ALWAYS HIT PLAYER WITH LESS HP WHEN PLAYERS ARE WITHIN A DISTANCE OF 10 METERS", "HIT PLAYER WHO LAST HIT ENEMY" AND "HIT PLAYER WHO FIRST HIT ENEMY" by removing the /* and */ that surround the option with the function and by adding it to the other options

/* "ALWAYS HIT PLAYER WITH LESS HP WHEN PLAYERS ARE WITHIN A DISTANCE OF 10 METERS" Hook */

func void B_AssessEnemy ()
{
	if (Cast_InstanceToPointer(hero_2) == Cast_InstanceToPointer(other) || Cast_InstanceToPointer(hero) == Cast_InstanceToPointer(other)){
		if (Npc_GetDistToNpc(hero, hero_2) < 1000)
		{
			if (hero_2.attribute[ATR_HITPOINTS] < hero.attribute[ATR_HITPOINTS])
			{
				other = Cast_PointerToInstance(Cast_InstanceToPointer(hero_2));
			}else if (hero_2.attribute[ATR_HITPOINTS] > hero.attribute[ATR_HITPOINTS])
			{
				other = Cast_PointerToInstance(Cast_InstanceToPointer(hero));
			};
		};
	};
	B_AssessEnemy_old();
};
func void B_MM_AssessEnemy ()
{
	if (Cast_InstanceToPointer(hero_2) == Cast_InstanceToPointer(other) || Cast_InstanceToPointer(hero) == Cast_InstanceToPointer(other)){
		if (Npc_GetDistToNpc(hero, hero_2) < 1000)
		{
			if (hero_2.attribute[ATR_HITPOINTS] < hero.attribute[ATR_HITPOINTS])
			{
				other = Cast_PointerToInstance(Cast_InstanceToPointer(hero_2));
			}else if (hero_2.attribute[ATR_HITPOINTS] > hero.attribute[ATR_HITPOINTS])
			{
				other = Cast_PointerToInstance(Cast_InstanceToPointer(hero));
			};
		};
	};
	B_MM_AssessEnemy_old();
};

func int ZS_MM_Attack_Loop ()
{
	if (Cast_InstanceToPointer(hero_2) == Cast_InstanceToPointer(other) || Cast_InstanceToPointer(hero) == Cast_InstanceToPointer(other)){
		if (Npc_GetDistToNpc(hero, hero_2) < 1000)
		{
			if (hero_2.attribute[ATR_HITPOINTS] < hero.attribute[ATR_HITPOINTS])
			{
				Npc_SetTarget(self, hero_2);
			}else if (hero_2.attribute[ATR_HITPOINTS] > hero.attribute[ATR_HITPOINTS])
			{
				Npc_SetTarget(self, hero);
			};
		};
	};
	return ZS_MM_Attack_Loop_old();
};

func int ZS_Attack_Loop ()
{
	if (Cast_InstanceToPointer(hero_2) == Cast_InstanceToPointer(other) || Cast_InstanceToPointer(hero) == Cast_InstanceToPointer(other)){
		if (Npc_GetDistToNpc(hero, hero_2) < 1000)
		{
			if (hero_2.attribute[ATR_HITPOINTS] < hero.attribute[ATR_HITPOINTS])
			{
				Npc_SetTarget(self, hero_2);
			}else if (hero_2.attribute[ATR_HITPOINTS] > hero.attribute[ATR_HITPOINTS])
			{
				Npc_SetTarget(self, hero);
			};
		};
	};
	return ZS_Attack_Loop_old();
};


func void B_AssessDamage ()
{
	if (Cast_InstanceToPointer(hero_2) == Cast_InstanceToPointer(other) || Cast_InstanceToPointer(hero) == Cast_InstanceToPointer(other)){
		if (Npc_GetDistToNpc(hero, hero_2) > 1000)
		{
			Npc_SetTarget(self, other);
		};
	};
	B_AssessDamage_old();
};

func void B_MM_AssessDamage ()
{
	if (Cast_InstanceToPointer(hero_2) == Cast_InstanceToPointer(other) || Cast_InstanceToPointer(hero) == Cast_InstanceToPointer(other)){
		if (Npc_GetDistToNpc(hero, hero_2) > 1000)
		{
			Npc_SetTarget(self, other);
		};
	};
	B_MM_AssessDamage_old();
};

/* "HIT PLAYER WHO LAST HIT ENEMY" Hook */

/*
func void B_AssessDamage ()
{
	if (Npc_IsInState(self,ZS_Attack))
	{
		if (Hlp_GetInstanceID (hero_2) == self.aivar[AIV_LASTTARGET])
		{
			Npc_SetTarget (self, other);
		};
	};
	B_AssessDamage_old();
};

func void B_MM_AssessDamage ()
{
	if (Npc_IsInState(self,ZS_MM_Attack))
	{
		if (Hlp_GetInstanceID (hero_2) == self.aivar[AIV_LASTTARGET]){
			Npc_SetTarget (self, other);
		};
	};
	B_MM_AssessDamage_old();
};
*/

/* "HIT PLAYER WHO FIRST HIT ENEMY" Hook */

/*
//Standard option which doesn't need any hooks
*/

//CHOOSE BETWEEN "XP-SHARE HOOK", "HALF XP-SHARE HOOK" AND "EACH PLAYER GETS OWN XP" by removing the /* and */ that surround the option with the function and by adding it to the other options

/* XP-Share Hook */

func void B_GivePlayerXP (var int add_xp)
{
	
	var int placeholder; placeholder = Cast_InstanceToPointer(hero);
	hero = Cast_PointerToInstance(Cast_InstanceToPointer(hero_2));
	B_GivePlayerXP_old(add_xp);
	hero = Cast_PointerToInstance(placeholder);
	B_GivePlayerXP_old(add_xp);
};


/* Half XP-Share Hook */

/*
func void B_GivePlayerXP (var int add_xp)
{
	
	var int placeholder; placeholder = Cast_InstanceToPointer(hero);
	hero = Cast_PointerToInstance(Cast_InstanceToPointer(hero_2));
	B_GivePlayerXP_old(add_xp/2);
	hero = Cast_PointerToInstance(placeholder);
	B_GivePlayerXP_old(add_xp/2);
};
*/


/* Each player gets his own XP */

/*
const int player_1_getsXP = 0;
const int player_2_getsXP = 0;

func void B_GivePlayerXP (var int add_xp)
{
	var int placeholder; placeholder = Cast_InstanceToPointer(hero);
	
	if (((Cast_InstanceToPointer(other) == Cast_InstanceToPointer(hero_2)) || (Cast_InstanceToPointer(self) == Cast_InstanceToPointer(hero_2)))){
		player_2_getsXP = 1;
		hero = Cast_PointerToInstance(Cast_InstanceToPointer(hero_2));
	}else if (((Cast_InstanceToPointer(other) == Cast_InstanceToPointer(hero)) || (Cast_InstanceToPointer(self) == Cast_InstanceToPointer(hero)))){
		player_1_getsXP = 1;
	};
	
	B_GivePlayerXP_old(add_xp);
	
	hero = Cast_PointerToInstance(placeholder);
	player_1_getsXP = 0;
	player_2_getsXP = 0;
};
*/
